<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Creating Core CarbonPHP Libraries</h1>

		<p>When CarbonPHP runs it initialises several libraries as part of the core.  It is posssible to replace or
		extend any of the core libraries with your own libraries.</p>

		<p><i>Note</i>: Many users will not need to extend or replace these core libraries.  Although some users may
		wish to change the CarbonPHP core.</p>
	</div>

	<div class="content">
		<h1>CarbonPHP Core Libraries</h1>

		<p>This is a list of the core libraries CarbonPHP will load when it runs.</p>

		<ul>
			<li>Benchmark</li>
			<li>Config</li>
			<li>Controller</li>
			<li>Extensions</li>
			<li>Input</li>
			<li>Language</li>
			<li>Loader</li>
			<li>Output</li>
			<li>Router</li>
			<li>URI</li>
		</ul>
	</div>

	<div class="content">
		<h1>Replacing Core Libraries</h1>

		<p>To replace one of the core libraries simple create your library in the <b>application/libraries/</b>
		directory.</p>

		<div class="example">
			application/libraries/<b>some_core_library.php</b>
		</div>

		<p>Any library named identically to one of the above core libraries will be loaded instead of the CarbonPHP
		library.  <i>Note</i>: your class name must also use the <b>Carbon_</b> prefix.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Carbon_Output<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>
	</div>

	<div class="content">
		<h1>Extending Core Libraries</h1>

		<p>If you only need to add a little functionality to a core library you can extend the library using a
		subclass.</p>

		<ul>
			<li>The class declaration must extend the parent class.</li>
			<li>The new class name and file name must be prefixed with the subclass prefix.</li>
		</ul>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Sub_Output extends Carbon_Output<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>If you want to use a constructor in your subclass you need to remember to call the parent classes
		constructor.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			if (!defined('CARBON_PATH'))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;exit('Direct script access is not allowed.');<br />
			&#125;<br />
			<br />
			class Sub_Output extends Carbon_Output<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p><i>Note</i>: any methods you create that are named identically to methods in the parent class will
		override the parent methods.</p>

		<p>You can set your own subclass prefix in the configuration file <b>application/config/config.php</b> and
		edit the <b>subclass_prefix</b> value.</p>

		<div class="example">
			$config['subclass_prefix'] = 'Sub_';
		</div>
	</div>
</body>

</html>
